package utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class JoinResults {
	
	private FileUtils f = new FileUtils();

	public JoinResults() throws IOException{
		File dir = new File("results_inducer");
		BufferedWriter out = f.createOut("totalRes");
		Map<String, String> runMap = new HashMap<String, String>();
		for (String folder:dir.list()){
			File folderFile = new File(dir+"/"+folder);
			File testFile = folderFile.listFiles()[0].listFiles()[0];
			if (testFile.isDirectory()){
				for (String sub:folderFile.list()){
					String run = writeRes(dir+"/"+folder+"/"+sub);
					runMap.put(dir+"_"+folder+"_"+sub, run);
				}
			}
			else {
				String run = writeRes(dir+"/"+folder);
				runMap.put(dir+"_"+folder, run);
			}
		}
		for (String key:runMap.keySet()){
			out.write(key+"\n"+runMap.get(key)+"\n\n");
		}
		out.close();
	}
	
	private String writeRes(String folder) throws IOException{
		//For all the corpora
		File folderFile = new File(folder);
		
		Map<String, List<String>> map = new HashMap<String, List<String>>();
		for (String corpus:folderFile.list()){
			List<String> corpusTot = new ArrayList<String>();
			BufferedReader in = f.createIn(folder+"/"+corpus+"/log");
			List<String> log = new ArrayList<String>();
			String line;
			//Skip first line
			line=in.readLine();
			while ((line=in.readLine())!=null){
				String[] splits = line.split("\\s+");
				if (splits.length < 5)
					log.add((splits[1]+"\t"+splits[2]+"\t"+splits[3]));
				else 
					log.add((splits[1]+"\t"+splits[4]+"\t"+splits[5]));
			}
			
			in = f.createIn(folder+"/"+corpus+"/out.tagDist");
			List<String> tagDist = new ArrayList<String>();
			while ((line=in.readLine())!=null){
				String[] splits = line.split("\\s+");
				tagDist.add(splits[1]);
			}
			//Merge the two lists
			for (int i = 0; i < log.size(); i++){
				if (i < tagDist.size()) corpusTot.add(log.get(i)+"\t"+tagDist.get(i)+"\t\t");
				else corpusTot.add(log.get(i)+"\t\t\t");
			}
			map.put(corpus, corpusTot);
		}
		String out = "";
		int max = 0;
		for (String key:map.keySet()){
			out += key+"\t\t\t\t\t";
			if (map.get(key).size() > max) max = map.get(key).size();
		}
		out += "\n";
		for (int i = 0; i < max; i++){
			for (String key:map.keySet()){
				if (i < map.get(key).size()) out += map.get(key).get(i);
				else out += "\t\t\t\t\t\t";
			}
			out += "\n";
		}
		return out;
	}

	public static void main(String[] args) {
		try {new JoinResults();}
		catch (IOException e){e.printStackTrace();}
	}
}
